---
title: CSSPrimitiveValue
slug: Web/API/CSSPrimitiveValue
tags:
  - API
  - CSSOM
  - CSSPrimitiveValue
  - Interface
  - Obsolete
  - Reference
---
<div>{{APIRef("CSSOM")}}</div>

<p>The <code><strong>CSSPrimitiveValue</strong></code> interface derives from the {{DOMxRef("CSSValue")}} interface and represents the current computed value of a CSS property.</p>

<p>This interface represents a single CSS value. It may be used to determine the value of a specific style property currently set in a block or to set a specific style property explicitly within the block. An instance of this interface might be obtained from the {{DOMxRef("CSSStyleDeclaration.getPropertyCSSValue()", "getPropertyCSSValue()")}} method of the {{DOMxRef("CSSStyleDeclaration")}} interface. A <code>CSSPrimitiveValue</code> object only occurs in a context of a CSS property.</p>

<p>Conversions are allowed between absolute values (from millimeters to centimeters, from degrees to radians, and so on) but not between relative values. (For example, a pixel value cannot be converted to a centimeter value.) Percentage values can't be converted since they are relative to the parent value (or another property value). There is one exception for color percentage values: since a color percentage value is relative to the range 0-255, a color percentage value can be converted to a number (see also the {{DOMxRef("RGBColor")}} interface).</p>

<p>{{InheritanceDiagram}}</p>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent, <code>{{DOMxRef("CSSValue")}}</code></em>.</p>

<dl>
 <dt>{{DOMxRef("CSSPrimitiveValue.primitiveType")}} {{readonlyInline}}</dt>
 <dd>An <code>unsigned short</code> representing the type of the value. Possible values are:
 <table class="standard-table">
  <tbody>
   <tr>
    <td class="header">Constant</td>
    <td class="header">Description</td>
   </tr>
   <tr>
    <td><code>CSS_ATTR</code></td>
    <td>The value is an {{CSSxRef("attr()")}} function. The value can be obtained by using the <code>getStringValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_CM</code></td>
    <td>The value is a {{CSSxRef("&lt;length&gt;")}} in centimeters. The value can be obtained by using the <code>getFloatValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_COUNTER</code></td>
    <td>The value is a <a href="/en-US/docs/Web/CSS/CSS_Lists_and_Counters/Using_CSS_counters">counter or counters</a> function. The value can be obtained by using the <code>getCounterValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_DEG</code></td>
    <td>The value is an {{CSSxRef("&lt;angle&gt;")}} in degrees. The value can be obtained by using the <code>getFloatValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_DIMENSION</code></td>
    <td>The value is a {{CSSxRef("&lt;number&gt;")}} with an unknown dimension. The value can be obtained by using the <code>getFloatValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_EMS</code></td>
    <td>The value is a {{CSSxRef("&lt;length&gt;")}} in em units. The value can be obtained by using the <code>getFloatValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_EXS</code></td>
    <td>The value is a {{CSSxRef("&lt;length&gt;")}} in ex units. The value can be obtained by using the <code>getFloatValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_GRAD</code></td>
    <td>The value is an {{CSSxRef("&lt;angle&gt;")}} in grads. The value can be obtained by using the <code>getFloatValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_HZ</code></td>
    <td>The value is a {{CSSxRef("&lt;frequency&gt;")}} in Hertz. The value can be obtained by using the getFloatValue method.</td>
   </tr>
   <tr>
    <td><code>CSS_IDENT</code></td>
    <td>The value is an identifier. The value can be obtained by using the <code>getStringValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_IN</code></td>
    <td>The value is a {{CSSxRef("&lt;length&gt;")}} in inches. The value can be obtained by using the <code>getFloatValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_KHZ</code></td>
    <td>The value is a {{CSSxRef("&lt;frequency&gt;")}} in Kilohertz. The value can be obtained by using the <code>getFloatValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_MM</code></td>
    <td>The value is a {{CSSxRef("&lt;length&gt;")}} in millimeters. The value can be obtained by using the <code>getFloatValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_MS</code></td>
    <td>The value is a {{CSSxRef("&lt;time&gt;")}} in milliseconds. The value can be obtained by using the <code>getFloatValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_NUMBER</code></td>
    <td>The value is a simple {{CSSxRef("&lt;number&gt;")}}. The value can be obtained by using the <code>getFloatValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_PC</code></td>
    <td>The value is a {{CSSxRef("&lt;length&gt;")}} in picas. The value can be obtained by using the <code>getFloatValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_PERCENTAGE</code></td>
    <td>The value is a {{CSSxRef("&lt;percentage&gt;")}}. The value can be obtained by using the <code>getFloatValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_PT</code></td>
    <td>The value is a {{CSSxRef("&lt;length&gt;")}} in points. The value can be obtained by using the <code>getFloatValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_PX</code></td>
    <td>The value is a {{CSSxRef("&lt;length&gt;")}} in pixels. The value can be obtained by using the <code>getFloatValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_RAD</code></td>
    <td>The value is an {{CSSxRef("&lt;angle&gt;")}} in radians. The value can be obtained by using the <code>getFloatValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_RECT</code></td>
    <td>The value is a {{CSSxRef("shape", "rect()", "#Syntax")}} function. The value can be obtained by using the <code>getRectValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_RGBCOLOR</code></td>
    <td>The value is an {{CSSxRef("&lt;color&gt;")}}. The value can be obtained by using the <code>getRGBColorValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_S</code></td>
    <td>The value is a {{CSSxRef("&lt;time&gt;")}} in seconds. The value can be obtained by using the <code>getFloatValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_STRING</code></td>
    <td>The value is a {{CSSxRef("&lt;string&gt;")}}. The value can be obtained by using the <code>getStringValue()</code> method.</td>
   </tr>
   <tr>
    <td><code>CSS_UNKNOWN</code></td>
    <td>The value is not a recognized CSS2 value. The value can only be obtained by using the {{DOMxRef("CSSValue.cssText", "cssText")}} attribute.</td>
   </tr>
   <tr>
    <td><code>CSS_URI</code></td>
    <td>The value is a {{CSSxRef("&lt;uri&gt;")}}. The value can be obtained by using the <code>getStringValue()</code> method.</td>
   </tr>
  </tbody>
 </table>
 </dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{DOMxRef("CSSPrimitiveValue.getCounterValue()")}}</dt>
 <dd>This method is used to get the <a href="/en-US/docs/Web/CSS/CSS_Lists_and_Counters/Using_CSS_counters">counter</a> value. If this CSS value doesn't contain a counter value, a {{DOMxRef("DOMException")}} is raised. Modification to the corresponding style property can be achieved using the {{DOMxRef("Counter")}} interface.</dd>
 <dt>{{DOMxRef("CSSPrimitiveValue.getFloatValue()")}}</dt>
 <dd>This method is used to get a float value in a specified unit. If this CSS value doesn't contain a float value or can't be converted into the specified unit, a {{DOMxRef("DOMException")}} is raised.</dd>
 <dt>{{DOMxRef("CSSPrimitiveValue.getRGBColorValue()")}}</dt>
 <dd>This method is used to get the RGB color. If this CSS value doesn't contain a RGB color value, a {{DOMxRef("DOMException")}} is raised. Modification to the corresponding style property can be achieved using the {{DOMxRef("RGBColor")}} interface.</dd>
 <dt>{{DOMxRef("CSSPrimitiveValue.getRectValue()")}}</dt>
 <dd>This method is used to get the Rect value. If this CSS value doesn't contain a rect value, a {{DOMxRef("DOMException")}} is raised. Modification to the corresponding style property can be achieved using the {{DOMxRef("Rect")}} interface.</dd>
 <dt>{{DOMxRef("CSSPrimitiveValue.getStringValue()")}}</dt>
 <dd>This method is used to get the string value. If the CSS value doesn't contain a string value, a {{DOMxRef("DOMException")}} is raised.</dd>
 <dt>{{DOMxRef("CSSPrimitiveValue.setFloatValue()")}}</dt>
 <dd>A method to set the float value with a specified unit. If the property attached with this value can not accept the specified unit or the float value, the value will be unchanged and a {{DOMxRef("DOMException")}} will be raised.</dd>
 <dt>{{DOMxRef("CSSPrimitiveValue.setStringValue()")}}</dt>
 <dd>A method to set the string value with the specified unit. If the property attached to this value can't accept the specified unit or the string value, the value will be unchanged and a {{DOMxRef("DOMException")}} will be raised.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Style', 'css.html#CSS-CSSPrimitiveValue', 'CSSPrimitiveValue')}}</td>
   <td>{{Spec2('DOM2 Style')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.CSSPrimitiveValue")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("CSSValue")}}</li>
 <li>{{DOMxRef("CSSValueList")}}</li>
</ul>
